<?php

namespace Drupal\entity_preprocess_services\PreprocessService;

use Drupal\Core\Entity\EntityInterface;

/**
 * Class PreprocessServiceBase.
 *
 * @package Drupal\entity_preprocess_services\PreprocessService
 */
abstract class PreprocessServiceBase implements PreprocessServiceInterface {

  /**
   * The entity.
   *
   * @var \Drupal\Core\Entity\EntityInterface
   */
  protected $entity;

  /**
   * The view mode.
   *
   * @var string
   */
  protected $viewMode;

  /**
   * The variables.
   *
   * @var array
   */
  protected $variables;

  /**
   * {@inheritdoc}
   */
  public function preprocess(): array {
    return $this->variables;
  }

  /**
   * {@inheritdoc}
   */
  public function setEntity(EntityInterface $entity): PreprocessServiceInterface {
    $this->entity = $entity;
    return $this;
  }

  /**
   * {@inheritdoc}
   */
  public function setViewMode(string $viewMode): PreprocessServiceInterface {
    $this->viewMode = $viewMode;
    return $this;
  }

  /**
   * {@inheritdoc}
   */
  public function setVariables(array &$variables): PreprocessServiceInterface {
    $this->variables = $variables;
    return $this;
  }

}
